function terraincheck(start,drawpath,optimization,ignore,storage,storage2,storage3)
	storage3 = false;
	for i = 1, math.floor(drawpath.Magnitude/optimization) do
		storage = Vector(start.X,start.Y) + Vector(i*optimization,0):RadRotate(drawpath.AbsRadAngle);
		storage2 = SceneMan:GetTerrMatter(storage.X,storage.Y);
		if storage2 ~= ignore and storage2 ~= 0 then
			storage3 = true
			break;
		end
	end
	return storage3
end

function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.directionlistX = {0,0,1,-1};
	self.directionlistY = {1,-1,0,0};
	self.checklist = {};
	self.targlist = nil;
	self.lastmove = nil;
	self.moved = false;
	if self.Sharpness == 1 then
		self.lifetimer = Timer();
	end

	self.scantimer = Timer();
	self.thornchance = 700; -- the probability of placing a thorn every frame, 1 out of x.
	self.huntscandelay = 500; -- delay time between object scans
	self.canhunt = true; -- can the vine chase objects?
	self.huntrange = 100;



end

function Update(self)
	self.ToDelete = false;
	self.ToSettle = false;
	self.PinStrength = 1000;

	if (self.Sharpness == 1 and self.lifetimer:IsPastSimMS(60000)) or ((SceneMan.SceneWrapsX == false and self.Pos.X > SceneMan.SceneWidth or self.Pos.X < 0) or (SceneMan.SceneWrapsY == false and self.Pos.Y > SceneMan.SceneHeight or self.Pos.Y < 0)) then
		self.ToDelete = true;
	end

	if SceneMan:GetTerrMatter(self.Pos.X,self.Pos.Y) == 0 then

		self.modetecter = SceneMan:GetMOIDPixel(self.Pos.X,self.Pos.Y);

		if (self.Mass == 1 and (math.random(1,self.thornchance) == self.thornchance or self.modetecter ~= 255)) or (self.Mass == 2 and self.modetecter ~= 255) then
			self.thorn = CreateMOSParticle("Creeper Vines Thorn");
			self.thorn.Pos = self.Pos;
			MovableMan:AddParticle(self.thorn);
			self.thorn = nil;
		end

		if self.modetecter == 255 then
			self.terrpar = CreateMOPixel("Particle Creeper Vines Terrain "..math.random(1,3));
			self.terrpar.Pos = self.Pos;
			MovableMan:AddParticle(self.terrpar);
			self.terrpar.ToSettle = true;
			self.terrpar = nil;
		end

	end

	self.moved = false;
	self.checklist = {};

	for i = 1, #self.directionlistX do
		if SceneMan:GetTerrMatter(self.Pos.X+self.directionlistX[i],self.Pos.Y+self.directionlistY[i]) == 0 then
			self.checklist[#self.checklist+1] = Vector(self.directionlistX[i],self.directionlistY[i]);
			self.moved = true;
		end
	end

	if self.canhunt == true and (self.Mass == 1 or self.Mass == 2) then
		self.target = nil;
		if self.scantimer:IsPastSimMS(self.huntscandelay) == true then

			self.scantimer:Reset();
			self.movetopos = nil;
			self.lastscandist = nil;

			for i = 1,MovableMan:GetMOIDCount()-1 do
				self.objectscanner = MovableMan:GetMOFromID(i);
				self.curdist = SceneMan:ShortestDistance(self.Pos,self.objectscanner.Pos,self.mapwrapx);
				if self.curdist.Magnitude <= self.huntrange and (self.lastscandist == nil or (self.lastscandist ~= nil and self.curdist.Magnitude < self.lastscandist)) then
					self.terrvector = Vector(0,0);
				--	self.terrcheck = SceneMan:CastStrengthRay(self.Pos,self.curdist,0,self.terrvector,1,5,self.mapwrapx);
					self.terrcheck = terraincheck(self.Pos,self.curdist,2,5);

					if self.terrcheck == false then
						self.lastscandist = self.curdist.Magnitude;
						self.target = self.objectscanner;

					end
				end
			end
			self.lastscandist = nil;
			if self.target ~= nil then
--[[
				for i = 1, #self.checklist do
					self.curdist = SceneMan:ShortestDistance(self.Pos+Vector(self.checklist[i].X,self.checklist[i].Y),self.target.Pos,self.mapwrapx);
					if self.lastscandist == nil or (self.lastscandist ~= nil and self.lastscandist < self.curdist.Magnitude) then
						self.movetopos = Vector(self.checklist[i].X,self.checklist[i].Y);
					end
				end
--]]
				self.curdist = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx);
				self.movetopos = Vector(self.curdist.X,self.curdist.Y):SetMagnitude(1);
				self.movetoposmatcheck = SceneMan:GetTerrMatter(self.Pos.X+self.movetopos.X,self.Pos.Y+self.movetopos.Y);
				if self.movetoposmatcheck ~= 0 and self.movetoposmatcheck ~= 5 then
					self.movetopos = nil;
				end
			end
			self.target = nil;
		end
		if self.movetopos ~= nil then
				self.targetmove = Vector(self.movetopos.X,self.movetopos.Y);
		end
	end

	if self.lastmove ~= nil then
		for i = 1, #self.checklist do
			if Vector(self.lastmove.X,self.lastmove.Y) == Vector(self.checklist[i].X,self.checklist[i].Y) then
				for g = 1, 1 do
					self.checklist[#self.checklist+1] = Vector(self.lastmove.X,self.lastmove.Y);
				end
				break;
			end
		end
	end

	if self.moved == true then
		if self.targetmove ~= nil then
			self.lastmove = Vector(self.targetmove.X,self.targetmove.Y);
			self.checkpos = self.Pos + Vector(self.lastmove.X,self.lastmove.Y);
			self.asdf = SceneMan:GetTerrMatter(self.checkpos.X,self.checkpos.Y);
			if self.asdf == 0 or asdf == 5 then
				self.Pos = self.checkpos;
			else
				self.targetmove = nil;
			end
		end
		if self.targetmove == nil then
			self.lastmove = self.checklist[math.random(1,#self.checklist)];
			self.Pos = self.Pos + Vector(self.lastmove.X,self.lastmove.Y);
		end
	else
		self.probnum = math.random(1,4);
		self.destination = Vector(self.Pos.X+self.directionlistX[self.probnum],self.Pos.Y+self.directionlistY[self.probnum]);
		self.matercheck = SceneMan:GetTerrMatter(self.destination.X,self.destination.Y);
		if self.matercheck == 0 or self.matercheck == 5 then
			self.Pos = Vector(self.destination.X,self.destination.Y);
		end
	end

	self.targetmove = nil;

end